﻿Module WKGlobals
  Public RX As String

  'WinKey global vars and constants are created as 2 byte arrays.
  'In some cases the second byte is not needed and should not be sent to WK.
  'Immediate Admin Commands  ONLY when host mode closed
  Public AdminReset(1) As Byte
  Public AdminOpen(1) As Byte
  Public AdminClose(1) As Byte
  Public AdminEcho(1) As Byte
  Public AdminGetValues(1) As Byte  'Only when WK closed...
  Public AdminSetWK1Mode(1) As Byte
  Public AdminSetWK2Mode(1) As Byte
  Public AdminDumpEPROM(1) As Byte
  Public AdminNull(3) As Byte

  'Immediate Host Mode Commands- WK Open
  Public HostSideToneControl(1) As Byte
  Public HostSetWPMSpeed(1) As Byte
  Public HostSetWeighting(1) As Byte
  Public HostSetPTTLeadTail(2) As Byte
  Public HostSetUpSpeedPot(3) As Byte
  Public HostSetPauseGO(1) As Byte
  Public HostSetPauseSTOP(1) As Byte
  Public HostGetSpeedPotVal(1) As Byte
  Public HostBackspace(1) As Byte
  Public HostSetPinConfig(1) As Byte  'NOTE... Hi and Lo Nibble coded
  Public HostClearWKBuffer(1) As Byte
  Public HostKeyDown(1) As Byte
  Public HostKeyUp(1) As Byte
  Public HostSetHSCW(1) As Byte
  Public HostSetFarnsWPM(1) As Byte
  Public HostSetWK2Mode(1) As Byte  'Bit wacking required 
  Public HostLoadDefaults(15) As Byte  'Array is actually a value list
  Public HostSet1stExtension(1) As Byte  'Lead in time extension for older XCVRs
  Public HostSetKeyCompenstaion(1) As Byte
  Public HostNullCommand(1) As Byte
  Public HostSetPaddleSwitchpoint(1) As Byte
  Public HostSoftwarePaddle(1) As Byte
  Public HostRequestWK2Status(1) As Byte
  Public HostPointerCommand(1) As Byte
  Public HostSetDidDahRatio(1) As Byte

  'Buffered Commands... WK must be open...
  Public BuffPTTOnOff(1) As Byte
  Public BuffKeyDown(1) As Byte
  Public BuffWait(1) As Byte
  Public BuffMergeLetters(2) As Byte
  Public BuffChangeSpeedWPM(1) As Byte
  Public BuffHSCWChangeSpeed(1) As Byte
  Public BuffCancelBufferedSpeedChange(1) As Byte
  Public BuffNOP(1) As Byte

  Public Sub SetWinkeyGlobals()  'Called on form load
    'Immediate Admin Commands  WK Closed....
    AdminReset(0) = 0  'Reset to power up state
    AdminReset(1) = 1

    AdminOpen(0) = 0   'Host mode open... returns version
    AdminOpen(1) = 2

    AdminClose(0) = 0  'Host mode Close.  Returns to stand by mode
    AdminClose(1) = 3

    AdminEcho(0) = 0   'Echo... next byte sent will be echoed back.
    AdminEcho(1) = 4

    AdminGetValues(0) = 0  'Get internal setup parms... closed mode only
    AdminGetValues(1) = 7

    AdminSetWK1Mode(0) = 0   'Set WK1 mode disable PushBtn reporting.
    AdminSetWK1Mode(1) = 10

    AdminSetWK2Mode(0) = 0   'Set WK2 mode enable PustBtn Reporting
    AdminSetWK2Mode(1) = 11

    AdminDumpEPROM(0) = 0   'Dump WK2 EEPROM 256 bytes...
    AdminDumpEPROM(1) = 12

    AdminNull(0) = 17  'Setup of 4 nulls to sent on connect....
    AdminNull(1) = 17
    AdminNull(2) = 17
    AdminNull(3) = 17

    'Immediate Host Mode Commands- WK Open
    HostSideToneControl(0) = 1
    HostSideToneControl(1) = 5 'Default tone of 800 Hz

    HostSetWPMSpeed(0) = 2
    HostSetWPMSpeed(1) = 18  'Set default WPM at 24WPM

    HostSetWeighting(0) = 3
    HostSetWeighting(1) = 32 'Set default Weight at 50, no adjustment

    HostSetPTTLeadTail(0) = 4
    HostSetPTTLeadTail(1) = 1   'Lead delay 10 ms, 
    HostSetPTTLeadTail(2) = 10  'Tail delay 160 ms as default

    HostSetUpSpeedPot(0) = 5
    HostSetUpSpeedPot(1) = 16  'Set Min WPM at 16 WPM.
    HostSetUpSpeedPot(2) = 30  'Set Range at 30, for a top of 46 WPM
    HostSetUpSpeedPot(3) = 0   'Dont care byte.....Send for compatiblility

    HostSetPauseGO(1) = 6
    HostSetPauseGO(1) = 0
    HostSetPauseSTOP(1) = 6
    HostSetPauseSTOP(1) = 1

    HostGetSpeedPotVal(0) = 7

    HostBackspace(0) = 8  'Single byte used.....
    HostBackspace(0) = 0  'Not used.... dont send 

    HostSetPinConfig(0) = 9  'WK1 compatibility command....
    HostSetPinConfig(0) = 0  'Check manual for nibble and overload definitions

    HostClearWKBuffer(0) = 10 'Second byte dont care, dont send.

    HostKeyDown(0) = 11
    HostKeyDown(1) = 1
    HostKeyUp(0) = 11
    HostKeyUp(1) = 0

    HostSetHSCW(0) = 12
    HostSetHSCW(1) = 12

    HostSetFarnsWPM(0) = 12
    HostSetFarnsWPM(1) = 12

    HostSetWK2Mode(0) = 14
    HostSetWK2Mode(1) = 0 '

    'Default block load default settings
    HostLoadDefaults(0) = 15   'A list of 15 values Follows same valuse as individual cmds
    HostLoadDefaults(1) = 13  'Mode Register
    HostLoadDefaults(2) = 0   'Speed in WPM
    HostLoadDefaults(3) = 5   'SideTone Freq -800Hz
    HostLoadDefaults(4) = 32   'Weight
    HostLoadDefaults(5) = 1   'Lead in time
    HostLoadDefaults(6) = 10   'Tail time
    HostLoadDefaults(7) = 10   'Min WPM for pot
    HostLoadDefaults(8) = 30   'Range WPM for pot
    HostLoadDefaults(9) = 0   '1st Extension
    HostLoadDefaults(10) = 10 'Key Compensation- 10
    HostLoadDefaults(11) = 12  'Farnsworth WPM
    HostLoadDefaults(12) = 50  'Paddle Setpoint
    HostLoadDefaults(13) = 50  'Did/Dah Ratio  -50 is 1:3
    HostLoadDefaults(14) = 0  'Pin Configuration-????
    HostLoadDefaults(15) = 0  'Dont care... set to 0
    'End default block

    'More Immediate Host Mode Commands- WK Open
    HostSet1stExtension(0) = 16
    HostSet1stExtension(1) = 0

    HostSetKeyCompenstaion(0) = 10
    HostSetKeyCompenstaion(1) = 0

    HostNullCommand(0) = 19
    HostNullCommand(1) = 0

    HostSetPaddleSwitchpoint(0) = 18
    HostSetPaddleSwitchpoint(1) = 50

    HostSoftwarePaddle(0) = 20
    HostSoftwarePaddle(1) = 0  'Default to paddle up Dit, Dah, or Both are also settings

    HostRequestWK2Status(0) = 21
    HostRequestWK2Status(1) = 0

    HostPointerCommand(0) = 22
    HostPointerCommand(1) = 0

    HostSetDidDahRatio(0) = 23
    HostSetDidDahRatio(1) = 12

    'Buffered Command default setup
    BuffPTTOnOff(0) = 24
    BuffPTTOnOff(1) = 0

    BuffKeyDown(0) = 25
    BuffKeyDown(1) = 0

    BuffWait(0) = 26
    BuffWait(1) = 0

    BuffMergeLetters(0) = 27
    BuffMergeLetters(1) = 0
    BuffMergeLetters(2) = 0

    BuffChangeSpeedWPM(0) = 28
    BuffChangeSpeedWPM(1) = 32

    BuffHSCWChangeSpeed(0) = 29
    BuffHSCWChangeSpeed(1) = 0

    BuffCancelBufferedSpeedChange(0) = 30
    BuffCancelBufferedSpeedChange(1) = 0  'Do not send second byte... single byte cmd

    BuffNOP(0) = 31     'Do not send second byte... single byte cmd
    BuffNOP(1) = 0

  End Sub
End Module
