﻿Module WKModeCode
  'Most of this is just stuff started and not finished.
  Public Function WK2Status(ByVal StatusByte As Byte) As Boolean
    Dim Ret As Boolean = False  'Return var for function call.
    Dim MsgTxt As String = ""   'A string to send to the message display function
    Dim MsgColor As Color = Color.White  'Default color for timed messages.

    'The "binary or" operation sets any bits to 1 in the result if either (or both) 
    'of the two numbers has a 1 in its corresponding bits.

    'To toggle any bit, simply "binary xor" the number with a 1 set in the 
    'appropriate bit position. If the corresponding bit is 1, the result bit is 0 etc. 

    'AND "b = a and Bit(0)" will result in b=1 if that bit is set in a.....

    'Set up some check vars to check the bits
    'Load up the check vars based on bits set or not in the status byte.
    Dim B7 As Byte = StatusByte And &H80  '3 MSBs should be set....
    Dim B6 As Byte = StatusByte And &H40
    Dim B5 As Byte = StatusByte And &H20
    Dim WaitChk4 As Byte = StatusByte And &H10
    Dim KeyDown3 As Byte = StatusByte And &H8
    Dim CWChk2 As Byte = StatusByte And &H4
    Dim PadBrkInChk1 As Byte = StatusByte And &H2
    Dim XOFFChk0 As Byte = StatusByte And &H1

    If WaitChk4 = 0 Then  'Not waiting for internal event to finish
      MsgTxt = "WK-NoWait  "
    ElseIf WaitChk4 = 16 Then     'if = 16 Wait is in progress 
      MsgTxt = "WK-Waiting  "
    End If

    If KeyDown3 = 0 Then  'In WK1 compat mode, this is Keydown indicator
      MsgTxt = MsgTxt + "Key-Up  "
    ElseIf KeyDown3 = 8 Then  'if = 8 it is a Paddle Button Status byte... 
      MsgTxt = MsgTxt + "Key-Dn  "
    End If

    If CWChk2 = 0 Then 'CW sending is over
      MsgTxt = MsgTxt + "Clear-CW  "
    ElseIf CWChk2 = 4 Then 'It would be = 4 if sending...
      MsgTxt = MsgTxt + "Sending-CW  "
      MsgColor = Color.LightSalmon   'Set red color for sending CW.
    End If

    If PadBrkInChk1 = 0 Then 'Paddle Breakin is not set
      MsgTxt = MsgTxt + "PdlBrk-Clr  "
    ElseIf PadBrkInChk1 = 2 Then
      MsgTxt = MsgTxt + "PdlBrk-Set  "     'if = 2 Paddle Breakin is set
    End If

    If XOFFChk0 = 0 Then  'Buffer not reaching full
      MsgTxt = MsgTxt + "Buf-OK  "
    ElseIf XOFFChk0 = 1 Then   'if = 1 Buffer is 2/3 or more full....
      MsgTxt = MsgTxt + "Buf-Warn  "
    End If

    Ret = TimedMessage(MsgTxt, 1000, MsgColor)  'Timed message function

  End Function

  Public Function TimedMessage(ByVal Msg As String, ByVal Msecs As Integer, ByVal BackColor As Color) As Boolean
    'General timed message show function
    frmWKTest.tmrMessage.Stop()

    frmWKTest.lblCWBusy.Text = Msg
    frmWKTest.tmrMessage.Interval = Msecs
    frmWKTest.lblCWBusy.BackColor = BackColor

    frmWKTest.tmrMessage.Start()
    Return True

  End Function

  Public Sub EchoToggle()

    If frmWKTest.cmdEchoToggle.Text = "Echo is on" Then
      Try
        'Set the echo bit off.
        HostSetWK2Mode(1) = 0
        frmWKTest.serialPort.Write(HostSetWK2Mode, 0, 2) 'Write bytes, starting at 0, count of 2
        frmWKTest.cmdEchoToggle.Text = "Echo is off"
      Catch ex As Exception
        MsgBox(ex.ToString)
      End Try
    ElseIf frmWKTest.cmdEchoToggle.Text = "Echo is off" Then
      Try
        'Set the echo bit on.
        HostSetWK2Mode(1) = 4
        frmWKTest.serialPort.Write(HostSetWK2Mode, 0, 2) 'Write bytes, starting at 0, count of 2
        frmWKTest.cmdEchoToggle.Text = "Echo is on"
      Catch ex As Exception
        MsgBox(ex.ToString)
      End Try
    End If
    frmWKTest.txtDataToSend.Focus()
  End Sub

  Public Sub RequestWK2Status()
    'Single byte command, &H15
    frmWKTest.serialPort.Write(HostRequestWK2Status, 0, 1)
  End Sub

  Public Sub SetWK2ModeByte()
    'Single byte bit field
    '7 -MSB = Disable Paddle Watchdog
    '6 -Paddle Echoback 1= enableed 0= disabled
    '5 -With bit 4, 00= Iambic B, 01= Iambic A
    '4 -  10= Ultimatic,  11= Bug Mode
    '3 -Paddle Swap  1-Swap, 0= Normal
    '2 -Serial Echoback  1=Enabled, 0=Disabled
    '1 -Autospace  1=enabled,  0=disabled
    '0 -LSB  -CT Spacing when =1, normal wordspace when =0

  End Sub

  Public Sub LoadDefaults()
    ' 0F and a list of 15 binary values
    'Public HostLoadDefaults(15) As Byte  'Array is actually a value list
    'Default block load default settings
    HostLoadDefaults(0) = 15   'A list of 15 values Follows same valuse as individual cmds
    HostLoadDefaults(1) = 13  'Mode Register
    HostLoadDefaults(2) = 0   'Speed in WPM
    HostLoadDefaults(3) = 5   'SideTone Freq -800Hz
    HostLoadDefaults(4) = 32   'Weight
    HostLoadDefaults(5) = 1   'Lead in time
    HostLoadDefaults(6) = 10   'Tail time
    HostLoadDefaults(7) = 10   'Min WPM for pot
    HostLoadDefaults(8) = 30   'Range WPM for pot
    HostLoadDefaults(9) = 0   '1st Extension
    HostLoadDefaults(10) = 10 'Key Compensation- 10
    HostLoadDefaults(11) = 12  'Farnsworth WPM
    HostLoadDefaults(12) = 50  'Paddle Setpoint
    HostLoadDefaults(13) = 50  'Did/Dah Ratio  -50 is 1:3
    HostLoadDefaults(14) = 0  'Pin Configuration-????
    HostLoadDefaults(15) = 0  'Dont care... set to 0
    'End default block





  End Sub





End Module
